<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:xd="http://www.oxygenxml.com/ns/doc/xsl"
    xmlns="http://www.w3.org/1999/xhtml"
    xmlns:func="http://oxygenxml.com/samples/books"
    exclude-result-prefixes="xs xd"
    xpath-default-namespace="http://oxygenxml.com/samples/books"
    version="2.0">
    <xd:doc>
        <xd:desc>
            <xd:p>Generates an index for the given books.</xd:p>
        </xd:desc>
        <xd:param name="books">The books to generate the index for.</xd:param>
    </xd:doc>
    <xsl:function name="func:generateIndex">
        <xsl:param name="books"/>
        <!-- Index  -->
        <xsl:for-each select="$books">
            <xsl:call-template name="createIndexItem">
                <xsl:with-param name="bookAnchor" select="@anchor"/>
                <xsl:with-param name="bookName" select="title"/>
                <xsl:with-param name="bookAuthor" select="author"/>
            </xsl:call-template>
        </xsl:for-each>
    </xsl:function>
</xsl:stylesheet>